<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama CCTV" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'cctv', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah CCTV
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="cctvs" ref="cctvTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Nama CCTV"
                width="300">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Deskripsi"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.description }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="URL"
                width="200">
                <template slot-scope="scope">
                    <span>{{ scope.row.url }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Status"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.status == 'online'" type="success" size="mini">Online</el-tag>
                    <el-tag v-else type="info" size="mini">Offline</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                label="Perumahan"
                width="300"
                v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                <template slot-scope="scope">
                    <span>{{ scope.row.residential.name }}</span>
                </template>
            </el-table-column>            
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'cctv', 'viewother']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'cctv', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch"/>

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="cctvForm" :model="cctvForm" :rules="cctvRules">
                <aside>
                    <el-alert type="info" description="Mengatur daftar semua CCTV untuk masing-masing perumahan." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Nama" prop="name">
                    <el-input ref="name" name="name" v-model="cctvForm.name" placeholder="Nama CCTV" autocomplete="off" maxlength="255" show-word-limit></el-input>
                </el-form-item>  
                <el-form-item label="Deskripsi" prop="description">
                    <el-input type="textarea" ref="description" name="description" v-model="cctvForm.description" placeholder="Catatan" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                </el-form-item> 
                <el-form-item label="URL" prop="url">
                    <el-input ref="url" name="url" v-model="cctvForm.url" placeholder="http://username:password@domain.com" autocomplete="off" maxlength="255" show-word-limit>
                    </el-input>
                </el-form-item>              
                <el-row :gutter="20">
                    <el-col :lg="12" :md="24" :sm="24">
                         <el-form-item label="Status" prop="status">
                            <el-select v-model="cctvForm.status" placeholder="Pilih status" class="width-100" ref="status" name="status">
                                <el-option
                                    v-for="item in status"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>  
                    <el-col :lg="12" :md="24" :sm="24" v-if="['root', 'owner'].indexOf(me.role.slug) > -1">
                        <el-form-item label="CCTV Perumahan" prop="residential">
                            <el-select v-model="cctvForm.residential" placeholder="Pilih perumahan" class="width-100" ref="residential" name="residential">
                                <el-option
                                    v-for="item in residentials"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">                                    
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>

                <el-form-item label="" prop="showMap">
                    <el-checkbox v-model="showMap">Detil Lokasi</el-checkbox>
                </el-form-item>
                <GmapMap 
                    id="map"
                    v-if="showMap == true" 
                    ref="mapRef"
                    :options="{
                        zoomControl: true,
                        mapTypeControl: false,
                        scaleControl: false,
                        streetViewControl: false,
                        rotateControl: false,
                        fullscreenControl: true,
                        disableDefaultUi: false
                    }"
                    :zoom="map.zoom"
                    :center="map.center">
                    <GmapMarker ref="markerRef" :position="map.center" :draggable="true" @dragend="handleMoveMarker($event)"/>
                </GmapMap>                
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'cctv', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import {gmapApi} from 'vue2-google-maps';
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'ResidentReport',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        var validateResidential = (rule, value, callback) => {
            if(['root', 'owner'].indexOf(this.me.role.slug) > -1 && this.cctvForm.residential == null){
                return callback(new Error('Perumahan wajib dipilih'));
            }
            callback();
        };

        return {
            tableLoading: false,
            dialogLoading: false,
            filterLoading: false,
            showMap: false,
            map: {
                zoom: 14,
                center: {
                    lat: -2.9760735,
                    lng: 104.77543070000002
                }
            },
            status: [{
                label: 'Online',
                value: 'online'
            }, {
                label: 'Offline',
                value: 'offline'
            }],
            filter: {
                keyword: '',
                status: null,
                residential: null          
            },
            showDialog: false,
            showFilterDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah CCTV',
                create: 'Tambah CCTV'
            },
            cctvForm: {
                id: null,
                name: null,
                status: null,
                url: '',
                description: '',
                residential: null,
                latitude: null,
                longitude: null,
                archived: false
            },
            cctvRules: {
                name: [{ 
                    required: true, message: 'Nama CCTV wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama CCTV maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,?]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                status: [{
                    required: true, message: 'Status CCTV wajib diisi', trigger: 'change'
                }],
                url: [{
                    required: true, message: 'URL wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'URL maksimal 255 karakter', trigger: 'blur'
                }],
                description: [{
                    max: 255, message: 'Deskripsi maksimal 255 karakter', trigger: 'blur'
                }],
                residential: [{
                    validator: validateResidential, trigger: 'change'
                }]
            }
        };
    },
    computed: {
        tableHeight,
        google: gmapApi,
        ...mapGetters('auth', ['token']),
        ...mapGetters('user', ['me']),
        ...mapGetters('residential', ['residentials']),
        ...mapGetters('cctv', [
            'cctvs',
            'pagination'
        ]),
    },
    created() {
        this.getCCTVs();
        this.getResidentials();
    },
    methods: {
        playSound,
        dateFormat,
        getCCTVs() {
            this.tableLoading = true;
            this.$store.dispatch('cctv/getCCTVs', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getResidentials() {
            this.tableLoading = true;
            this.$store.dispatch('residential/getResidentials', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;                
            });
        },
        handleSearch(){

            this.showFilterDialog = false;

            let payload = {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }

            if(this.filter.status != null){
                payload['status'] = this.filter.status;
            }

            if(this.filter.residential != null){
                payload['residential'] = this.filter.residential;
            }

            this.tableLoading = true;
            this.$store.dispatch('cctv/getCCTVs', payload).then(() => {
                this.tableLoading = false;
            });
        },
        handleMoveMarker(e){
            this.cctvForm.latitude = e.latLng.lat();
            this.cctvForm.longitude = e.latLng.lng();

            var self = this;

            setTimeout(() => {
                self.$refs.mapRef.$mapPromise.then((map) => {
                    map.setZoom(18);
                    map.panTo({lat: e.latLng.lat(), lng: e.latLng.lng()});
                });
            }, 100);
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.$nextTick(() => {
                this.$refs['cctvForm'].clearValidate();
            });
        },
        handleEdit(cctv){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.cctvForm.id = cctv.id;
            this.cctvForm.name = cctv.name;
            this.cctvForm.url = cctv.url;
            this.cctvForm.latitude = cctv.latitude;
            this.cctvForm.longitude = cctv.longitude;
            this.cctvForm.status = cctv.status;
            this.cctvForm.description = cctv.description;
            this.cctvForm.residential = cctv.residential.id; 
            this.cctvForm.archived = cctv.archived;

            if(cctv.latitude && cctv.longitude){
                this.showMap = true;
                this.map.center.lat = cctv.latitude;
                this.map.center.lng = cctv.longitude;

                var self = this;

                setTimeout(() => {
                    self.$refs.mapRef.$mapPromise.then((map) => {
                        map.setZoom(18);
                        map.panTo(self.map.center);
                    });
                }, 100);
            }

            this.$nextTick(() => {
                this.$refs['cctvForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.cctvForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'cctv/addCCTV';
                        payload = {
                            name: this.cctvForm.name,
                            url: this.cctvForm.url,
                            latitude: this.cctvForm.latitude,
                            longitude: this.cctvForm.longitude,
                            status: this.cctvForm.status,
                            description: this.cctvForm.description,
                            residential: this.cctvForm.residential
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'cctv/editCCTV';
                        payload = {
                            id: this.cctvForm.id,
                            name: this.cctvForm.name,
                            url: this.cctvForm.url,
                            latitude: this.cctvForm.latitude,
                            longitude: this.cctvForm.longitude,
                            status: this.cctvForm.status,
                            description: this.cctvForm.description,
                            residential: this.cctvForm.residential,
                            archived: this.cctvForm.archived
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(cctv){
            this.$confirm('Anda mencoba untuk menghapus data CCTV, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('cctv/deleteCCTV', {
                    id: cctv.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.cctvForm = {
                id: null,
                name: null,
                status: null,
                url: '',
                description: '',
                residential: null,
                latitude: null,
                longitude: null,
                archived: false
            }

            this.showMap = false;
            this.map = {
                zoom: 14,
                center: {
                    lat: -2.9760735,
                    lng: 104.77543070000002
                }
            };
        }
    }

}
</script>
<style>
    #map{
        width: 100%;
        height: 400px;
    }
</style>